;;; Avoid a conflict with the package :GL of SBCL's CLX that was introduced
;;; with the GLX extensions support of SBCL CLX version 0.6.1.
(delete-package 'gl)
(require :cube-modeller)
(in-package "SB-ALIEN")

(let ((function (symbol-function 'try-reopen-shared-object)))
  (setf (symbol-function 'try-reopen-shared-object)
	#'(lambda (obj)
	    (declare (type shared-object obj))

	    ;; (format  *trace-output* "~&>>> 1) desired shared-object: ~d" (shared-object-file obj))
            (when (and ;; a hack for the file "sbcl/contrib/sb-bsd-sockets/alien.so"
                       (string= (pathname-name (shared-object-file obj))
                                "alien")
                       (string= (car (last (pathname-directory (shared-object-file obj))))
                                "sb-bsd-sockets"))
              (setf (shared-object-file obj)
                    (make-pathname :name "alien-bsd"
                                   :defaults (shared-object-file obj))))
            (setf (shared-object-file obj)
                  (file-namestring (shared-object-file obj)))
	    ;; (format  *trace-output* "~&>>> 2) now searching instead: ~d" (shared-object-file obj))
            
            (funcall function obj))))

(in-package :cl-user)
(setf *invoke-debugger-hook* nil) ;; Use SBCL's built-in debugger while loading the foreign objects.

(sb-ext:save-lisp-and-die "cube-modeller.core"
			  :toplevel (lambda ()
                                      (setf *invoke-debugger-hook* #'clim-debugger:debugger)

                                      (format t "~&~%=============== LED Cube Modeller ===============~&~%")
                                      
				      (setf cube::*device-file*
                                            (sb-ext:posix-getenv "CUBETTY")

                                            cube-modeller::*animation-pathname*
                                            (merge-pathnames (make-pathname :directory '(:relative "data"))
                                                             (cl-fad:pathname-as-directory (SB-UNIX:POSIX-GETCWD))))
				      (when cube::*device-file*
					(format t "~&Writing cube data to device file \"~d\".~&~%" cube::*device-file*))
				      (cube-modeller:start)
				      (sb-ext:quit)))
